package security;

import classUtils.pack.DependencyUtils;
import sun.security.tools.JarSigner;

/**
 * DocJava, Inc. User: lyon Date: May 26, 2004
 * Time: 7:40:22 AM
 */
public class SignUtils {
       public static void main(String[] args) {
        jarIt();

    }
    public static void testPackSignAndVerify() {
        String className = "dhry.Main";

        String keystoreName = "keystore";
        String storepass = "password";
        String alias = "docjava";

        packSignAndVerify(className,
                          keystoreName,
                          storepass,
                          alias);
    }
    public static void packSignAndVerify() {
        packSignAndVerify(
                futils.In.getString("enter class name"),
                futils.Futil.getReadFile("select keystore")+"",
                futils.In.getString("enter password"),
                futils.In.getString("enter alias")
        );

    }


    public static void packSignAndVerify(
            String className,
            String keystoreName,
            String storepass,
            String alias) {
        String jarFileName = className + ".jar";
        DependencyUtils.pack(className,
                      jarFileName);
        sign(keystoreName,
             storepass,
             jarFileName,
             alias);

        verify(jarFileName);
    }
     public static void jarIt() {
         String a[] = {
             "-help"
         };
        sun.tools.jar.Main.main(a);
    }
    public static void sign(String keystoreName,
                            String storepass,
                            String jarFileName,
                            String alias) {
        JarSigner js = new JarSigner();

        String a[] = {
            "-keystore",
            keystoreName,
            "-storepass",
            storepass,
            jarFileName,
            alias

        };
        js.run(a);
    }
    /**
     * This method causes the callers thread of
     * execution to terminate after the run!
     * @param jarFileName
     */
    public static void verify(String jarFileName) {
        JarSigner js = new JarSigner();
        System.out.println("verifying:"+jarFileName);
        String a[] = {
            "-verify",
            "-verbose",
            jarFileName,

        };
        js.run(a);
    }
}
